package view.bean;

import javax.faces.component.html.HtmlInputHidden;
import javax.faces.event.ValueChangeEvent;

import model.queries.CountriesViewRowImpl;
import model.queries.RegionsViewRowImpl;

import oracle.adf.model.binding.DCIteratorBinding;
import oracle.adf.view.rich.component.rich.input.RichInputText;
import oracle.adf.view.rich.component.rich.input.RichSelectBooleanCheckbox;

import oracle.adf.view.rich.event.DialogEvent;

import oracle.jbo.Row;
import oracle.jbo.RowIterator;

import view.utils.ADFUtils;
import view.utils.JSFUtils;

public class Case2Bean {

    private HtmlInputHidden ih1;
    private RichInputText it2;

    public Case2Bean() {
    }

    public void onValueChange(ValueChangeEvent event) {
        if (event.getOldValue() != null) {

            Boolean check = (Boolean)event.getNewValue();
            RichSelectBooleanCheckbox checkBox =
                (RichSelectBooleanCheckbox)event.getSource();
            String sign = checkBox.getLabel();
            String id = sign.substring(1);

            DCIteratorBinding dcIb =
                ADFUtils.findIterator("RegionsView1Iterator");
            RegionsViewRowImpl regionRow =
                (RegionsViewRowImpl)dcIb.getCurrentRow();

            if (sign.startsWith("R")) { //region
                regionRow.setSelectedSign(check ? "Y" : "N");
                RowIterator countriesRi = regionRow.getCountriesView();
                while (countriesRi.hasNext()) {
                    CountriesViewRowImpl countryRow =
                        (CountriesViewRowImpl)countriesRi.next();
                    countryRow.setSelectedSign(check ? "Y" : "N");
                }
            } else if (sign.startsWith("C")) {
                RowIterator countriesRi = regionRow.getCountriesView();

                if (!check) {
                    regionRow.setSelectedSign("N");
                    while (countriesRi.hasNext()) {
                        CountriesViewRowImpl countryRow =
                            (CountriesViewRowImpl)countriesRi.next();
                        if (countryRow.getCountryId().equals(id)) {
                            countryRow.setSelectedSign("N");
                        }
                    }

                } else {
                    boolean allSelected = true;
                    while (countriesRi.hasNext()) {
                        CountriesViewRowImpl countryRow =
                            (CountriesViewRowImpl)countriesRi.next();
                        if (countryRow.getCountryId().equals(id)) {
                            countryRow.setSelectedSign("Y");
                            continue;
                        }

                        if (!countryRow.getSelectedStatus()) {
                            System.out.println(countryRow.getCountryName());
                            allSelected = false;  
                        }
                    }
                    regionRow.setSelectedSign(allSelected ? "Y" : "N");
                }
            }
        }
    }

    public void onSelectDialog(DialogEvent dialogEvent) {
        if (dialogEvent.getOutcome().equals(DialogEvent.Outcome.ok)) { //for Yes
           
            DCIteratorBinding dcIb =
                ADFUtils.findIterator("RegionsView1Iterator");
            Row[] regionRows = dcIb.getAllRowsInRange();
            StringBuilder sb = new StringBuilder("");
            for (int i = 0; i < regionRows.length; i++) {
                RegionsViewRowImpl regionRow =
                    (RegionsViewRowImpl)regionRows[i];
                System.out.println("++++++++++" + regionRow.getRegionName() +
                                   ":" + regionRow.getSelectedStatus());

                //
                if (regionRow.getSelectedStatus()) {
                    sb.append(i==0?regionRow.getRegionName():","+regionRow.getRegionName());
                                       
                    // ih1.setValue(regionRow.getRegionId());
                    ADFUtils.setBoundAttributeValue("regionId1",
                                                    regionRow.getRegionId());
                }

                RowIterator countryRi = regionRow.getCountriesView();
                while (countryRi.hasNext()) {
                    CountriesViewRowImpl countryRow =
                        (CountriesViewRowImpl)countryRi.next();
                    System.out.println("----------------" +
                                       countryRow.getCountryName() + ":" +
                                       countryRow.getSelectedStatus());
                }

            }
            it2.setValue(sb.toString());
        } else { //for Cancel
            System.out.println("close......");
        }
    }


    public void setIh1(HtmlInputHidden ih1) {
        this.ih1 = ih1;
    }

    public HtmlInputHidden getIh1() {
        return ih1;
    }

    public void setIt2(RichInputText it2) {
        this.it2 = it2;
    }

    public RichInputText getIt2() {
        return it2;
    }
}
